package cn.estsh.i3plus.core.apiservice.schedulejob;

import cn.estsh.i3plus.core.api.iservice.busi.ISysFileAttachService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysFileService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysLocaleLanguageService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysLocaleResourceService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysMessageService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysTaskCycleService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysTaskService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysToolService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysToolTypeService;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysFile;
import cn.estsh.i3plus.pojo.platform.bean.SysFileAttach;
import cn.estsh.i3plus.pojo.platform.bean.SysLocaleLanguage;
import cn.estsh.i3plus.pojo.platform.bean.SysLocaleResource;
import cn.estsh.i3plus.pojo.platform.bean.SysMessage;
import cn.estsh.i3plus.pojo.platform.bean.SysRefUserMessage;
import cn.estsh.i3plus.pojo.platform.bean.SysTask;
import cn.estsh.i3plus.pojo.platform.bean.SysTaskCycle;
import cn.estsh.i3plus.pojo.platform.bean.SysTool;
import cn.estsh.i3plus.pojo.platform.bean.SysToolType;
import cn.estsh.impp.framework.base.schedule.BaseImppScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @Description : 压力测试 CRUD
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2019-07-17 11:31
 * @Modify:
 **/
public class TestCRUDPressure extends BaseImppScheduleJob {

    private static final long serialVersionUID = -5611654157756961800L;
    @Autowired
    private ISysToolService sysToolService;

    @Autowired
    private ISysToolTypeService sysToolTypeService;

    @Autowired
    private ISysMessageService sysMessageService;

    @Autowired
    private ISysFileService sysFileService;

    @Autowired
    private ISysLocaleLanguageService sysLocaleLanguageService;

    @Autowired
    private ISysLocaleResourceService sysLocaleResourceService;

    @Autowired
    private ISysFileAttachService sysFileAttachService;

    @Autowired
    private ISysTaskService sysTaskService;

    @Autowired
    private ISysTaskCycleService sysTaskCycleService;


    private String testName = "定时任务压力测试 ";
    private String testUpdate = " 修改";

    public TestCRUDPressure() {
        super(TestCRUDPressure.class, "定时任务压力测试");
    }

    @Override
    public void executeImppJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        // 硬件
        // 新增
        SysToolType sysToolType = new SysToolType();
        sysToolType.setName(testName + "硬件类型");
        sysToolType = sysToolTypeService.insertSysToolType(sysToolType);

        SysTool sysTool = new SysTool();
        sysTool.setName(testName + "硬件");
        sysTool.setToolTypeId(sysToolType.getId());
        sysTool = sysToolService.insertSysTool(sysTool);

        SysMessage sysMessage = new SysMessage();
        sysMessage.setMessageTitle(testName + "消息");
        sysMessage = sysMessageService.insertSysMessage(sysMessage);

        SysRefUserMessage sysRefUserMessage = new SysRefUserMessage();
        sysRefUserMessage.setMessageTitleRdd(testName + "用户消息");
        sysRefUserMessage.setMessageId(sysMessage.getId());
        sysRefUserMessage = sysMessageService.insertSysRefUserMessage(sysRefUserMessage);

        SysFile sysFile = new SysFile();
        sysFile.setName(testName + "文件");
        sysFile.setFileCode(System.currentTimeMillis() + "-" + Math.random());
        sysFile = sysFileService.insertSysFile(sysFile);

        SysLocaleLanguage sysLocaleLanguage = new SysLocaleLanguage();
        sysLocaleLanguage.setLanguageName(testName + "语言");
        sysLocaleLanguage.setLanguageCode(System.currentTimeMillis() + "-" + Math.random());
        sysLocaleLanguage.setIsDefault(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        sysLocaleLanguage = sysLocaleLanguageService.insertSysLocaleLanguage(sysLocaleLanguage);

        SysLocaleResource sysLocaleResource = new SysLocaleResource();
        sysLocaleResource.setResourceKey(System.currentTimeMillis() + "-" + Math.random());
        sysLocaleResource.setLanguageCode(sysLocaleLanguage.getLanguageCode());
        sysLocaleResource = sysLocaleResourceService.insertSysLocaleResource(sysLocaleResource);

        SysFileAttach sysFileAttach = new SysFileAttach();
        sysFileAttach.setFileNameRdd(testName + "附件文件名称");
        sysFileAttach = sysFileAttachService.insertSysFileAttach(sysFileAttach);

        SysTask sysTask = new SysTask();
        sysTask.setName(testName + "任务 " + System.currentTimeMillis() + "-" + Math.random());
        sysTask = sysTaskService.insertSysTask(sysTask);

        SysTaskCycle sysTaskCycle = new SysTaskCycle();
        sysTaskCycle.setName(testName + "任务周期");
        sysTaskCycle = sysTaskCycleService.insertSysTaskCycle(sysTaskCycle);

        // 修改
        sysTool.setName(sysTool.getName() + testUpdate);
        sysToolService.updateSysTool(sysTool);

        sysToolType.setName(sysToolType.getName() + testUpdate);
        sysToolTypeService.updateSysToolType(sysToolType);

        sysMessage.setMessageTitle(sysMessage.getMessageTitle() + testUpdate);
        sysMessageService.updateSysMessage(sysMessage);

        sysRefUserMessage.setMessageSoftType(1);
        sysMessageService.insertSysRefUserMessage(sysRefUserMessage);

        sysFile.setName(sysFile.getName() + testUpdate);
        sysFileService.updateSysFile(sysFile);

        sysLocaleLanguage.setLanguageName(sysLocaleLanguage.getLanguageName() + testUpdate);
        sysLocaleLanguageService.updateSysLocaleLanguage(sysLocaleLanguage);

        sysLocaleResource.setResourceKey(sysLocaleResource.getResourceKey() + testUpdate);
        sysLocaleResourceService.updateSysLocaleResource(sysLocaleResource);

        sysFileAttach.setFileNameRdd(sysFileAttach.getFileNameRdd() + testUpdate);
        sysFileAttach.setRefId(sysMessage.getId());
        sysFileAttachService.insertSysFileAttach(sysFileAttach);

        sysTask.setName(sysTask.getName() + testUpdate);
        sysTaskService.updateSysTask(sysTask);

        sysTaskCycle.setName(sysTaskCycle.getName() + testUpdate);
        sysTaskCycleService.updateSysTaskCycle(sysTaskCycle);

        //查
        sysToolService.getSysToolById(sysTool.getId());
        sysToolTypeService.getSysToolTypeById(sysTool.getToolTypeId());
        sysMessageService.getSysMessageById(sysMessage.getId());
        sysMessageService.doGetSysMessageByRefUserMessageId(sysRefUserMessage.getId());
        sysFileService.getSysFileById(sysFile.getId());
        sysLocaleLanguageService.getSysLocaleLanguageById(sysLocaleLanguage.getId());
        sysLocaleResourceService.getSysLocaleResourceById(sysLocaleResource.getId());
        sysFileAttachService.findSysFileAttachByRefId(sysMessage.getId());
        sysTaskService.getSysTaskById(sysTask.getId());
        sysTaskCycleService.getSysTaskCycleById(sysTaskCycle.getId());

        // 删除
        sysToolService.deleteSysToolById(sysTool.getId());
        sysToolTypeService.deleteSysToolTypeById(sysTool.getToolTypeId());
        sysMessageService.deleteSysMessageById(sysMessage.getId());
        sysMessageService.deleteSysRefUserMessageById(sysRefUserMessage.getId());
        sysFileService.deleteSysFileById(sysFile.getId());
        sysLocaleResourceService.deleteSysLocaleResourceById(sysLocaleResource.getId());
        sysLocaleLanguageService.deleteSysLocaleLanguageById(sysLocaleLanguage.getId());
        sysFileAttachService.deleteSysFileAttachByRefId(sysMessage.getId());
        sysTaskService.deleteSysTaskById(sysTask.getId());
        sysTaskCycleService.deleteSysTaskCycleById(sysTaskCycle.getId());

    }
}
