package cn.estsh.i3plus.core.apiservice.util;

import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysConfig;
import cn.estsh.i3plus.pojo.platform.bean.SysDictionary;
import cn.estsh.i3plus.pojo.platform.bean.SysLocaleResource;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Description :
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2019-09-12 20:02
 * @Modify:
 **/
public class ResourceImportUtil {

    public static void main(String[] args) {
        File file = new File("C:\\Users\\yunha\\Desktop\\资源文件.xlsx");
        File sql = new File("C:\\Users\\yunha\\Desktop\\imppResource.sql");
        int i = 1;
        try {
            FileWriter fileWritter = new FileWriter(sql,false);
            BufferedWriter bufferWritter = new BufferedWriter(fileWritter);


            SnowflakeIdMaker snowflakeIdMaker = new SnowflakeIdMaker();
            Workbook wb = new XSSFWorkbook(file);
            // 前端资源
            Sheet webSheet = wb.getSheet("前端");
            Row row =null;
            SysLocaleResource sysLocaleResource = new SysLocaleResource();
            for (; i < webSheet.getLastRowNum(); i++) {
                row = webSheet.getRow(i);

                if(row == null||  row.getCell(2) == null||  row.getCell(3) == null){
                    continue;
                }
                System.out.println(snowflakeIdMaker.nextId()+"行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.WEB.getValue());
                sysLocaleResource.setResourceKey(row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(2).getStringCellValue());
                System.out.println(sql(sysLocaleResource));
                if(isContainChinese(row.getCell(2).getStringCellValue())){
                    bufferWritter.write(sql(sysLocaleResource));
                }

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.WEB.getValue());
                sysLocaleResource.setResourceKey(row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            // IMPP 资源
            Sheet imppSheet = wb.getSheet("IMPP");
            i =0;
            for (; i < imppSheet.getLastRowNum(); i++) {
                row = imppSheet.getRow(i);

//                if(row == null||  row.getCell(2) == null||  row.getCell(3) == null){
//                    continue;
//                }
                System.out.println(snowflakeIdMaker.nextId()+" IMPP 行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                if(isContainChinese(row.getCell(3).getStringCellValue())){
                    bufferWritter.write(sql(sysLocaleResource));
                }

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(4).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            // WMS资源
            Sheet wmsSheet = wb.getSheet("WMS");
            i =0;
            for (; i < wmsSheet.getLastRowNum(); i++) {
                row = wmsSheet.getRow(i);

                System.out.println(snowflakeIdMaker.nextId()+" WMS 行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                if(isContainChinese(row.getCell(3).getStringCellValue())){
                    bufferWritter.write(sql(sysLocaleResource));
                }

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(4).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            // ENUM
            Sheet enumSheet = wb.getSheet("ENUM");
            i =1;
            for (; i < enumSheet.getLastRowNum(); i++) {
                row = enumSheet.getRow(i);

                System.out.println(snowflakeIdMaker.nextId()+" ENUM 行:"+i);
                // 模块
                row.getCell(0).setCellType(CellType.STRING);
                // 枚举名称
                row.getCell(1).setCellType(CellType.STRING);
                // 枚举项名称
                row.getCell(2).setCellType(CellType.STRING);
                // 国际化（汉）
                row.getCell(3).setCellType(CellType.STRING);
                // 国际化（英）
//                row.getCell(4).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.ENUM.getValue());
                sysLocaleResource.setResourceKey(row.getCell(1).getStringCellValue()+":"+row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.ENUM.getValue());
                sysLocaleResource.setResourceKey(row.getCell(1).getStringCellValue()+":"+row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }



            // 字典
            Sheet dcSheet = wb.getSheet("字典");
            i =1;
            for (; i < dcSheet.getLastRowNum(); i++) {
                row = dcSheet.getRow(i);

                System.out.println(snowflakeIdMaker.nextId()+" 字典 行:"+i);
                row.getCell(0).setCellType(CellType.STRING);
                row.getCell(1).setCellType(CellType.STRING);
                row.getCell(2).setCellType(CellType.STRING);
                SysDictionary sysDictionary = new SysDictionary();
                sysDictionary.setId(Long.parseLong(row.getCell(0).getStringCellValue()));
                sysDictionary.setName(row.getCell(1).getStringCellValue());
                sysDictionary.setParentNameRdd(row.getCell(2).getStringCellValue());

                System.out.println(sql(sysDictionary));
                bufferWritter.write(sql(sysDictionary));
            }

            // 参数
            Sheet configSheet = wb.getSheet("参数");
            i =1;
            for (; i < configSheet.getLastRowNum(); i++) {
                row = configSheet.getRow(i);

                System.out.println(snowflakeIdMaker.nextId() + " 参数 行:" + i);
                row.getCell(0).setCellType(CellType.STRING);
                row.getCell(1).setCellType(CellType.STRING);
                row.getCell(2).setCellType(CellType.STRING);

                SysConfig sysConfig = new SysConfig();
                sysConfig.setId(Long.parseLong(row.getCell(0).getStringCellValue()));
                sysConfig.setName(row.getCell(1).getStringCellValue());
                sysConfig.setConfigDescription(row.getCell(2).getStringCellValue());

                System.out.println(sql(sysConfig));
                bufferWritter.write(sql(sysConfig));
            }

            bufferWritter.flush();
            bufferWritter.close();

            System.out.println("Done");
        } catch (IOException e) {
            System.out.println(i);
            e.printStackTrace();
        } catch (InvalidFormatException e) {
            System.out.println(i);
            e.printStackTrace();
        }
    }

    static int getType(String name){
        if("错误提示".equals(name.trim())){
            return CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.EXCEPTION_SOLUTION.getValue();
        }else {
            return CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.EXCEPTION_DETAIL.getValue();
        }
    }

    private static String sql(SysLocaleResource sysLocaleResource){
        return "insert into sys_locale_resource " +
                "(id,is_valid,is_deleted,create_user,create_date_time,modify_user,modify_date_time,resource_type,language_code," +
                "language_name_rdd,resource_key,resource_value,is_system) " +
                "values " +
                "("+sysLocaleResource.getId()+",1,2,\"system\",\"" + TimeTool.getNowTime(true)+"\",\"system\",\"" + TimeTool.getNowTime(true)+
                "\","+sysLocaleResource.getResourceType()+",\""+sysLocaleResource.getLanguageCode()+"\",\""+sysLocaleResource.getLanguageNameRdd()+"\",\""
        +sysLocaleResource.getResourceKey().replaceAll("\"","\\\\\\\"").trim()+"\",\""+sysLocaleResource.getResourceValue().replaceAll("\"","\\\\\\\"").trim()+"\",1);\n";
    }


    private static String sql(SysConfig sysConfig){
        return "UPDATE `sys_config` SET `config_description` = '"+sysConfig.getConfigDescription()+"', `name` = '"+sysConfig.getName()+
                "' WHERE `id` = "+sysConfig.getId()+" ;\n";
    }

    private static String sql(SysDictionary sysDictionary){
        return "UPDATE `sys_dictionary` SET `name` = '"+sysDictionary.getName().replaceAll("'","\\\\\\'")+"', `parent_name_rdd` =" +
                " '"+sysDictionary.getParentNameRdd().replaceAll("'","\\\\\\'")+
                "' WHERE `id` = " +
                sysDictionary.getId()+" ;\n";
    }


    /**
     * 判断字符串中是否包含中文
     * @param str
     * 待校验字符串
     * @return 是否为中文
     * @warn 不能校验是否为中文标点符号
     */
    public static boolean isContainChinese(String str) {
        Pattern p = Pattern.compile("[\u4e00-\u9fa5]");
        Matcher m = p.matcher(str);
        if (m.find()) {
            return true;
        }
        return false;
    }
}
